<?php
/** 
* html 관련 class
* 
* @filename : sky_html_class.php
* @version  : v 1.2 2003.02.12 16:30:22
*             v 1.0 2002.06.23 11:22:13
* @author    : nsl <smpoem@magicn.com>
* @access    : public
* @copyright : Copyright ⓒ 2002-2003 nsl All rights reserved.
*/
class SkyHtml {

    
	function SkyHtml() {

	}


   /**
    * select 문 출력
    *
    * @param   string  $varName   : select 태그 name
    * @param   array   $listMenu  : select 출력 이름
    * @param   array   $listValue : select value 값
    * @param   string  $selected  : 선택된 값
    * @param   string  $js        : 출력할 자바 스크립트
    * @param   string  $space     : html 출력시 공백
    * @param   string  $title     : 타이틀
    *
    * @access  public
    * @return  string  : select 출력 태그
    */
   function setSelectMenu($varName, &$listMenu, &$listValue, $selected, $js = '', $space = '', $title ='') {

	   $string .= "<select name='$varName' $js>\n";

       // 타이틀 생성
       if (!empty($title))
           $string .= "$space  <option value=''>$title\n";

	   for ( $z = 0; $z < count($listMenu); $z++ ) {

		   if ( $listValue[$z] != $selected )
			   $string .= "$space <option value='$listValue[$z]'>$listMenu[$z]\n";
		   else
			   $string .= "$space <option value='$listValue[$z]' selected>$listMenu[$z]\n";

       } // for End

	   $string .= "$space</select>";

	   return $string;
   }

   /**
   * select 문 출력 2
    *
    * @param   string  $varName   : select 태그 name
    * @param   array   $listMenu  : select 출력 이름 & value $test = array('name' => 이름)
    * @param   string  $selected  : 선택된 값
    * @param   string  $js        : 출력할 자바 스크립트
    * @param   string  $space     : html 출력시 공백
    * @param   string  $title     : 타이틀
    *
    * @access  public
    * @return  string  : select 출력 태그
    */
   function setSelectMenuKey($varName, &$listMenu, $selected, $js = '', $space = '', $title = '') {

	   $string .= "<select name='$varName' $js>\n";

       // 타이틀 생성
       if (!empty($title))
           $string .= "$space  <option value=''>$title\n";

       if (count($listMenu) > 0) {

           foreach($listMenu as $key => $val) {

	    	   if ( $key != $selected )
    			   $string .= "$space <option value='$key'>$val\n";
	    	   else
		    	   $string .= "$space <option value='$key' selected>$val\n";

           } // for End
       }

	   $string .= "$space</select>";

	   return $string;
   }

    /**
	 * 문자열을 원하는 길이로 잘라준다
     *
     * @param  string  $str    : 자를 문자열
     * @param  integer $maxLen : 제한 크기
     * @param  string  $mark   : 자른 후 뒷부분 처리 문자
     *
     * @access public
     */
    function skySubstr($str, $maxLen, $mark = "...") { 

        $strlen = strlen($str); 

		if ($strlen == ($maxLen + 1))
	        $strlen = strlen($str . ' '); 

        //   문자열길이 > 지정한 길이
        if ( $strlen > $maxLen ) { 
   
	        for($i = 0; $i < $strlen; $i++) { 

		        // 처음으로 $i값이 $MaxLen값보다 같거나 커졌을 경우 $MaxLen에 $i값 저장 
       	        if( $i >= $maxLen ) { 

                   $maxLen = $i;  break; 
                } 

                // 2바이트이면 한 칸 더 뒤로 이동 
                if( ord($str[$i]) >= 0x80)      $i++; 

           } // for end

           return substr($str, 0, $maxLen) . $mark; 

        } else {

             return $str;
        }

    } // skySubStr() End

   /**
    * PHP 설정에서 magic_quotes_gpc 가 off 일 경우에 assalsshes() 처리
    *
    * @param string $string 
    * 
    * @access public
    * @return string
    */
	function newAddslashes($string) {

		if (!get_magic_quotes_gpc()) {

			$string = addslashes($string);
		} 

		return $string;
	}

	/**
     * input 태그에서 글수정시 오류를 방지하기 위해서 " , ' -> html 문자로 변경한다
     *
     * @param string $string :
     * 
     * @access public
     * @return string
	 */
    function qMarkSpeicalChars($string) {

		$string = preg_replace("/\"/", "&quot;", $string);
		$string = preg_replace("/'/",  "&#039;", $string);

		return $string;
	}


	/**
	 * 내용을 자바스크립트로 출력할 수 있도록 변환
     *
     * @param string $string : 출력할 내용
     * 
     * @access public
     * @return string
	 */
    function getJsDocWrite($string) {

        $pattern = array("/\r/", "/\n/", "/'/");
        $replace = array("",  "",  "&#039;");

        $string = preg_replace($pattern, $replace, $string);
        $string = "<script language=\"javascript\">\n" .
                  "<!--\n" .
                  "    document.write('$string');\n" .
                  "//-->" .
                  "</script>";

        return $string;
    }


	/**
	 * POST, GET 방식의 모든 값을 추출해서 리턴 (로그인 폼에서 사용)
     * 
     * @access public
     * @return string
	 */
    function getRequestParam() {

        if (count($_GET)) {
		
            foreach($_GET as $key => $value)
    		    if ($key && $value) $url .= $key . "=" . $value . "&";
        }

        if (count($_POST)) {
		
	        foreach($_POST as $key => $value)
    		    if ($key && $value) $url .= $key . "=" . $value . "&";
        }

        return substr_replace( $url, "", -1 , 1); // 맨 마지막의 & 제거
    }


   /**
     * 원하는 범위의 숫자 배열 만들기
     * 
     * @param  integer $start : 시작 숫자
     * @param  integer $end   : 끝나는 숫자
     * @param  integer $minLen  : 자릿수
     * @param  string  $title : 타이틀
     * @param  boolean $isKey : 배열생성시 키 = 값 동일하게 생성
     *
     * @access public
     * @return array
     *
     * @example
     *   - getNumberList(1900, date('Y'), 4)  : 1900 ~ 현재 년도 구하기
     */
    function getNumberList($startNum, $endNum, $minLen, $title = '', $isKey = false) {

        $string = array();

        if ($title == '|space|') $string[] = '';
        else if (!empty($title)) $string[] = $title;

		for($z = $startNum; $z <= $endNum; $z++) {

            $y = $z;
			$yLength = strlen($y);

			if ( $yLength < $minLen ){

				for ($x = 0; $x < $yLength; $x++)
        					$y = '0' . $y;
			}

            if ($isKey)
    			$string[$y] = $y;
            else
    			$string[] = $y;
		}

		return $string;
	}

	/**
     * input text 태그를 생성한다
	 *
	 * @param  string  $name  : input 태그 name
	 * @param  integer $size  : input 태그 size
	 * @param  integer $size  : input 태그 maxlength
	 * @param  string  $size  : input 태그 value
	 * @param  string  $size  : input 태그 option
     *
     * @access public
     * @return string
     */
	function getInputTextTag($name, $size, $maxlength, $value = '', $option = '', $isReadonly = false) {
  
        // ' 의 오류 방지를 위해서
        if (!empty($value)) 
            $value = SkyHtml::qMarkSpeicalChars($value);

        if ($isReadonly) $readonly = "readonly";
		
    	return "<input type=text size=$size maxlength=$maxlength name=$name value=\"$value\" $option $readonly>";
	}

	/**
     * input password 태그를 생성한다
	 *
	 * @param  string  $name  : input 태그 name
	 * @param  integer $size  : input 태그 size
	 * @param  integer $size  : input 태그 maxlength
	 * @param  string  $size  : input 태그 value
	 * @param  string  $size  : input 태그 option
     *
     * @access public
     * @return string
	 */
	function getInputPasswordTag($name, $size, $maxlength, $value = '', $option = '') {
  
        // ' 의 오류 방지를 위해서
        if (!empty($value)) 
            $value = SkyHtml::qMarkSpeicalChars($value);

    	return "<input type=password size=$size maxlength=$maxlength name=$name value=\"$value\" $option>";
	}


	/**
     * input radio 태그를 생성한다
	 *
	 * @param  string  $name  : input 태그 name
	 * @param  string  $size  : input 태그 value
	 * @param  string  $size  : input 태그 option
     *
     * @access public
     * @return string
	 */
	function getInputRadioTag($name, $value = '', $option = '') {
  
        // ' 의 오류 방지를 위해서
        if (!empty($value)) 
            $value = SkyHtml::qMarkSpeicalChars($value);

        if ($isDisabled) $disabled = "disable";		
		
    	return "<input type=radio name=$name value=\"$value\" $option>";
	}

	/**
     * input checkbox 태그를 생성한다
	 *
	 * @param  string  $name  : input 태그 name
	 * @param  string  $size  : input 태그 value
	 * @param  string  $size  : input 태그 option
     *
     * @access public
     * @return string
     */
	function getInputCheckboxTag($name, $value = '', $option = '') {
  
        // ' 의 오류 방지를 위해서
        if (!empty($value)) 
            $value = SkyHtml::qMarkSpeicalChars($value);

        if ($isDisabled) $disabled = "disable";
		
    	return "<input type=checkbox name=$name value=\"$value\" $option>";
	}


    /**
     * MS Excel, Word, Powerpoint 로 받기
     *
     * @param  string  $filename : 저장할 파일명
     * @param  string  $type     : 문서 종류 excel, word, powerpoint
     *
     *
     * @access public
     * @return boolean
     */
    function getExcelHeader($filename, $type = 'excel') {

        $types = array('excel' => 'application/vnd.ms-excel',
                       'word'  => 'application/vnd.ms-word',
                       'powerpoint' => 'application/vnd.ms-powerpoint');

        header( "Content-type: " . $types[$type] . ""); 
        header( "Content-Disposition: attachment; filename=" . $filename . ".xls" ); 
        header( "Content-Description: PHP4 Generated Data" ); 

        return true;
    }


} // SkyHtmlClass() end