<?php
/** 
* image 크기 조정
* 
* @filename : sky_imgsize_class.php
* @version  : v 1.0 2003.05.22 15:29:32
* @author    : nsl <smpoem@magicn.com>
* @access    : public
* @copyright : Copyright ⓒ 2003 nsl All rights reserved.
*/

class SkyImgsize {

    // 기준 순서 widthMax -> heightMax -> percent
    var $widthMax  = 0;   // 0보다 크면 width 기준
    var $heightMax = 0;     // 0보다 크면 height 기준
    var $percent   = 0;     // 0보다 크면 percent 기준

    var $newImageWidth = 0;  // 최종 width
    var $newImageHeight = 0; // 최종 height

  	function SkyImgsize() {

	}

    /**
     * width 최대 크기 설정
     *
     * @param integer $width : width
     *
     * @access public
     * @return void;
     */
    function setWidthMax($width) {

        $this->widthMax = $width;
    }


    /**
     * height 최대 크기 설정
     *
     * @param integer $height : height
     *
     * @access public
     * @return void;
     */
    function setHeightMax($height) {

        $this->heightMax = $height;
    }

    /**
     * percent 설정
     *
     * @param integer $percent : percent
     *
     * @access public
     * @return void;
     */
    function setPercent($percent) {

        $this->percent = $percent;
    }

    
    /**
     * width 에 맞게 height 조절
     *
     * @param integer $width : width
     * @param integer $height : height
     *
     * @access private
     * @return void;
     */
    function getWidth($width, $height) {

	    $this->newImageWidth  = $this->widthMax;
     	$newWp     = (100 * $this->newImageWidth) / $width;
     	$this->newImageHeight = ($height * $newWp) / 100;

    }

    
    /**
     * height 에 맞게 width 조절
     *
     * @param integer $width : width
     * @param integer $height : height
     *
     * @access private
     * @return void;
     */
    function getHeight($width, $height) {

     	$this->newImageHeight = $this->heightMax;
     	$newHp     = (100 * $this->newImageHeight) / $height;
     	$this->newImageWidth  = ($width * $newHp) / 100;
    }
    
    /**
     * % 에 맞게 width, height 조절
     *
     * @param integer $width : width
     * @param integer $height : height
     *
     * @access private
     * @return void;
     */
    function getPercent($width, $height) {

	    $this->newImageWidth  = ($width * $this->percent) / 100;
     	$this->newImageHeight = ($height * $this->percent) / 100;
    }

    /**
     * 사이즈 조절  width --> height --> % 순
     *
     * @param integer $width : width
     * @param integer $height : height
     *
     * @access private
     * @return void;
     */
    function getImageSize($width, $height) {

        // 이미지 크기가 작으면 조정할 필요가 없다
        if ($width < $this->widthMax && $height < $this->heightMax) {

	        $this->newImageWidth  = $width;
		    $this->newImageHeight = $height;

			return;
		}

	    //^^^^^^^^^ width 값기준으로 조절
     	if ($this->widthMax > 0) {

     	    $this->getWidth($width, $height);
     
	        //^^^^^^^^ height 값이 Max 값을 초하면 height 값에 맞게 조절
     	    if ($this->heightMax > 0) {

       		     if ($this->newImageHeight > $this->heightMax)
     		        $this->getHeight($this->newImageWidth, $this->newImageHeight);
     	    }
     
     	}
     
	    // ^^^^^^^^^^^^ height 값에 맞게 조절 (max_width = 0 일 경우
     	if ($this->heightMax > 0 && $this->widthMax == 0) {

     	    $this->getHeight($width, $height);
     	}

        // ^^^^^^^^^^^^^ % 에 맞게 조절
     	if ($this->percent > 0) {
     	    
            $this->getPercent($width, $height);
     	}

        $this->newImageWidth  = round($this->newImageWidth);
        $this->newImageHeight = round($this->newImageHeight);

    } // getImageSize() End 

}