<?php
/**
* 사용함수 모음
*
* @filename : common/skydir_func.php
* @version  : v 1.1 2003.04.10 18:46:26 - sky_file_class.php 로 함수 분리함
*             v 1.0 2002.11.16 16:04:34
* @author   : nsl <smpoem@magicn.com>
*/


/**
* 숫자 가공
*
* @param  integer  $number : 숫자
* @param  integer  $decimals :  11.00 <-- . 뒤에 붙일 고정 0의 갯수 11 -> 11.00, 11.2 -> 11.20
* @param  string   $dec_point : 11.00 -> . 마크
* @param  string   $thousands_sep : 100,00 -> , 마크
*/
function getNumberFormat($number, $decimals = 0, $dec_point = '.', $thousands_sep = ',') {

    return number_format($number, $decimals, $dec_point, $thousands_sep);
}


// 환경 파일을 읽는다
function getConfigFile($filename) {

    global $dcfg;

    $file = $dcfg->configDir . '/' . $filename;

    if (!@is_file($file)) return false;
    if (!@is_readable($file)) return false;

    $fp = @fopen($file, 'r');
    if (!$fp) return false;

    $content = @fread($fp, @filesize($file));

    @fclose($fp);

    return  unserialize($content);
}

// 환경설정을 저장한다
function setConfigFile($filename, $cfgVar) {

    global $dcfg;

    $file = $dcfg->configDir . '/' . $filename;
    
    if (!@is_file($file)) return false;
    if (!@is_writeable($file)) return false;

    $fp = @fopen($file, 'w');
    if (!$fp) return false;

    
    @fwrite($fp, serialize($cfgVar));

    @fclose($fp);

    return true;
}

// 자바 스크립트 메세지만 띄움
function jsAlertMsg($string) {
    
    echo "<script language=\"javascript\">
          <!--
          window.alert(\"$string\");
          // -->
    	  </script>";
}

// 자바 스크립트 에러메세지
function jsAlertErrorMsg($string) {
    
    echo "<script language=\"javascript\">
          <!--
           window.alert(\"$string\");
           history.back();
          // -->
    	  </script>";

     exit();
}


// 웹에서 실행 가능한 절대경로 인가
function isWebRun($curdir) {

    global $rcfg;

    $curdir = $rcfg->userHomeDir . $curdir;

  
    if (ereg($rcfg->initDocumentRoot, $curdir)) return true;
    else                                        return false;
}

// 사용자의 홈디렉토리를 구한다
// @param string $ftpUserID : 사용자아이디
// @return string 
function getUserHomeDir($ftpUserID) {

    $temp = @posix_getpwnam($ftpUserID);

    return $temp['dir'];
}


// text 보기 가능한 text 파일인가
function isViewText($fileExt) {
     
    // 보기 가능한 확장자가 설정된 배열
    global $textViewExt;

    return in_array($fileExt, $textViewExt);

}

// img 보기 가능한 img 파일인가
function isViewImg($fileExt) {
     
    // 보기 가능한 확장자가 설정된 배열
    global $imgViewExt;

    return in_array($fileExt, $imgViewExt);

}


// top 메뉴에서 사용하는 현재 경로 링크
function getDirPos($cd) {
    
    // 현재 경로 
    if (!empty($cd)) {

        $cdList = explode("/", $cd);
    
        for($z = 1; $z < count($cdList); $z++) {

            $dirName = $cdList[$z];
        
            if (ereg("\.|\..", $dirName)) continue;

            $linkUrl .= '/' . $dirName; // urlencode($dirName) <-- 한글에러! | $dirName <- 공백에러!

            $tplList .= "<a href=javascript:topClick('$linkUrl')>$dirName</a>/";
        }

    return $tplList;
    }
}

// 시간구함
function getMicroTime() {
	
    $time = explode(" ", microtime());
    
    return $time[0] + $time[1]; # 0.19445200 983861131
}

// 사용자 아이디 구하기
function getUserID() {

    return $_COOKIE['_NFTP_USER_ID'];
}

// 로그인 유무
function isUserLogin() {

    if (!empty($_COOKIE['_NFTP_USER_ID']))
        return true;
    else
        return false;
}

// 로그인 체크
function isUserLoginCheck() {

    if (!isUserLogin()) {
    
        $errorMsg = "<font color=red>:: 로그인 이후에 이용하십시요!</font><br>";

        getGlobalErrorChk($errorMsg, "로그인 에러!");
        exit();
    }

    return true;
}

/**
 * 로그 남기기
 *
 * @param string  $msg : 로그 메세지
 * @param boolean $isDelete : true(로그지움)
*/
function setMyLog($msg, $isDelete = false) {

    global $dcfg;
    global $rcfg;

    // 로그 지우기 이면
    if($isDelete)
        $fileMode = 'w';
    else
        $fileMode = 'a+';

    // 로그 남기기 이면
    if ($rcfg->isLog) { 

        $logFp = fopen($dcfg->logFile, $fileMode);
 
        if(!$isDelete) {

            $date = date("Y-m-d H:i:s");
    
            $logMsg = $msg . ' - ' . $date . ' - ' . 'From : ' . $_SERVER['REMOTE_ADDR'] . "\n";
            fputs ($logFp, $logMsg);
        }

        fclose($logFp);
    }
}
 
// 암호화 
function getCrypt($str) {

    return crypt($str, CRYPT_BLOWFISH);
}

// 메타 태그를 이용한 이동
function metaGo( $go_url, $time = 0 ) {
    
    echo "<meta http-equiv='refresh' content='$time;url=$go_url'>";
    exit();
}

// 로그인 유무
function isLogin() {

    if ( !empty($_COOKIE['_NFTP_USER_ID']) ) 
        return true;
    else
        return false;
}

// 파일의 확장자 타입을 구한다
function getFileIcon($filename) {
  
    global $isImageFile;

    $isImageFile = false;

    $filename = strrchr($filename,'.'); // .gif

    $filetype = array('compress' => "compress.gif",
                     'exe'      =>  "exe.gif",
                     'help'     =>  "help.gif",
                     'html'     =>  "html.gif",

                     'jpg' =>      "jpg.gif",
                     'gif' =>   "gif.gif",
                     'bmp' =>   "bmp.gif",
                     'etcimg' => 'etcimg.gif',

                     'is' =>       "is.gif",
                     'movie' =>      "movie.gif",
                     'notepad' =>    "notepad.gif",
                     'ra' =>         "ra.gif",
                     'reg' =>      "reg.gif",
                     'sound' =>      "sound.gif",
                     'text' =>        "text.gif",
                     'swf' => 'swf.gif',

                     'xls' => 'xls.gif',
                     'doc' => 'doc.gif',
                     'ppt' => 'ppt.gif',
                      
                     'hwp' => 'hwp.gif',

                     'unknown' =>    "unknown.gif");

    if(eregi("zip|rar|tar|tgz", $filename) || eregi("tar", $mimetype)) return $filetype['compress'];

    else if(eregi("gif", $filename))        { $isImageFile = true; return $filetype['gif']; }
	else if(eregi("jpg",$filename))         { $isImageFile = true; return $filetype['jpg']; }
	else if(eregi("bmp",$filename))         { $isImageFile = true; return $filetype['bmp']; }
	else if(eregi("png",$filename))         { $isImageFile = true; return $filetype['etcimg']; }

    else if(eregi("exe", $filename))        return $filetype['exe'];
    else if(eregi("html|htm",$filename))    return $filetype['html'];
	else if(eregi("hlp", $filename))        return $filetype['help'];
    else if(eregi("txt|css|js", $filename)) return $filetype['text'];
    else if(eregi("wav|mp3", $filename))    return $filetype['sound'];
    else if(eregi("mov|ra|rm|asf|avi|wmv", $filename)) return $filetype['moving'];
    else if(eregi("swf|fla", $filename))    return $filetype['swf'];

    else if(eregi("xls", $filename))    return $filetype['xls'];
    else if(eregi("ppt", $filename))    return $filetype['ppt'];
    else if(eregi("doc", $filename))    return $filetype['doc'];

    else if(eregi("hwp", $filename))    return $filetype['hwp'];

    else return $filetype['unknown'];

} // getFileIcon() End


// 자바스크립트 출력
function fileJsPrint($str) {
    
    echo "<script language=\"javascript\">\n";
    echo "<!--\n";
    
    echo $str;

    echo "//-->\n";
    echo "</script>";
}

// 초기 디렉토리 구하기
// '/' 이면 공백 리턴
function getInitDirRight() {

    global $rcfg;

    if ($rcfg->initDirRight == "/")
        return '';
    else
        return $rcfg->initDirRight;
}



// 연결에러 메세지
function notConnectMsg() {

    global $isFtpCon;

    // FTP 접속이 실패했음을 알린다
    // 접속정보 설정에서 사용
    $isFtpCon = false;
?>
<script language="javascript">
<!--
    function connectWin() {

        // 기본 크기 설정
        var width  = 500;
        var height = 420;

        // center 위치 설정
       // var left = sky.getCenterPosLeft(width);
       // var top  = sky.getCenterPosTop(height);

        var left =100;
        var top  = 100;
        var option = 'width=' + width + ', height=' + height + ', left=' + left + ', top=' + top + ' ';
        winName = window.open('../php/connect_win.php?install=&wmode=nwin&code=connect_win', '' , option);
        winName.focus();

        return;

    }
	
connectWin();
//-->
</script>
    <table border=0 cellpadding=0 width=100% height=100% align=center>
    <tr>
      <td align=center valign=middle>

        <table border=0 cellpadding=0 width=240 height=100% align=center>
        <tr>
         <td align=center width=40>
           <img src="../image/mark_a32.gif" width=32 align=absmiddle>
         </td>
         <td width=200>
           <font color=#FE531E size=2><b>:: FTP 연결되지 않음</b></font><br>
           <font color=#FE531E size=2>:: <b>[접속 정보]</b>를 확인하십시요!</font>
         </td>
        </tr>
       </table>

     </td>
    </tr>
    </table>
<?
}


?>