<?php
/**
* uconfig.php 파일에 기본 환경설정
*
* @filename : config/uconfig_setting.php
* @version  : v 1.0 2003.07.18 18:30:46
* @author   : nsl <smpoem@magicn.com>
*/

// 이미 환경설정이 되어 있다면 에러!
if ((@filesize('uconfig.php') != 0 )) {
    
    Header("Location:../index.php");
    exit();
}

include '../common/skydir_config.php';

settype($ucfg, 'object');

// 설치된 정보를 설정해주면 됩니다.
$urlTemp = ereg_replace("/", "\/", dirname($_SERVER['PHP_SELF']));

// 사이트 홈 절대경로  예) /home/test/public_html
$ucfg->initDocumentRoot = preg_replace("/" . $urlTemp . "/", "", getcwd());

// 사이트 도메인       예) http://www.domain.com
$ucfg->initDomain  = 'http://' . $_SERVER['HTTP_HOST'];

// n 시작 디렉토리    
$ucfg->initDirRight = '';

// 파일보기 가능한 확장자
$ucfg->textViewExt = array("notext","asp","bat","c","cfg","conf","cpp","cgi","css","js",
                           "jsp","h","htm","html","inc","lib","pl","py","php","txt");

// 기본 언어
$ucfg->language = 'korean';

// 로그
$ucfg->isLog = true;

// 사용자 아이디
$ucfg->superID = base64_encode($dcfg->pgInitUserID);

// 사용자 비밀번호
$ucfg->superPW = getCrypt($dcfg->pgInitUserPW);

// 파일, 디렉토리 검색시 옵션
$ucfg->searchFileOption   = 1;   // 파일
$ucfg->searchFolderOption = 1;   // 디렉토리
$ucfg->searchEngOption    = 1;      // 대소문자 구분
$ucfg->searchSubdirOption = 1;  // 하위 디렉토리


// 환경설정 > 선택사항
$ucfg->isLog = true; // 로그 남기기 유무
$ucfg->isOnClickFolderOpen = false; // 한번 클릭으로 폴더열기

$ucfg->rightBgImage       = ''; // 이미지
$ucfg->rightBgImageRepeat = ''; // 반복
$ucfg->rightBgImagePos = ''; // 위치
$ucfg->rightBgImageOpacity = 100; // 투명도


// 오른쪽 프레임 정렬값
$ucfg->sortField  = 'name';
$ucfg->sortKey    = 'asc';

// 전체 창 크기 (초기값 -> 최대크기)
$ucfg->windowsWidth  = -1;
$ucfg->windowsHeight = -1;

// 마지막 원도우 크기로 실행
$ucfg->isWindowInitSize = true;

//^^^^^^^^^^^^^^ 이미지 관련 ^^^^^^^^^^^^^^^^^
// 미리 읽을 이미지 로딩 최대 갯수
$ucfg->imgReloadMax = 500;

// 단위 MByte, 1M당 약 10~15M의 메모리 소요 (컴퓨터마다 다름)
// 단 메모리는 유동적임
$ucfg->imgReloadMaxSize = 50;

// 이미지 모드에서 이미지 크기
$ucfg->imgThumbnailWidth  = 100;
$ucfg->imgThumbnailHeight = 100;

// 이미지 모드
$rcfg->isImageMode = false;
//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

// FTP 연결 정보
$ucfg->ftpHost = 'localhost';
$ucfg->ftpPort = '21';
$ucfg->ftpUserID = '';
$ucfg->ftpUserPW = '';
$ucfg->ftpPassiveMode = '';

// 환경설정을 저장한다
function setConfigFile($filename, $cfgVar) {

    global $ucfg;

    $file =  $filename;
    
    if (!is_file($file)) return false;
    if (!is_writeable($file)) return false;

    $fp = fopen($file, 'w');
    if (!$fp) return false;
    
    fwrite($fp, serialize($cfgVar));

    fclose($fp);

    return true;
}

function getCrypt($str) {

    return crypt($str, CRYPT_BLOWFISH);
}

Header("Location:../index.php?install=first");

// test code
if (setConfigFile('../config/uconfig.php', $ucfg))
    echo "ok";
else
    echo "error";



?>